classification
Title: test_win32 fails on aarch64
Type: crash Stage: resolved
Components: ctypes Versions: Python 3.4, Python 2.7
process
Status: closed Resolution: out of date
Dependencies: Superseder:
Assigned To: Nosy List: doko, iritkatriel, meador.inge, rkuska, sYnfo, vstinner
Priority: normal Keywords: patch

Created on 2015-01-16 09:41 by rkuska, last changed 2021-09-09 21:16 by iritkatriel. This issue is now closed.

Files
File name Uploaded Description Edit
libffi-henderson rkuska, 2015-01-16 09:41 fix by richard Henderson
libffi-mattip.patch rkuska, 2015-01-16 09:43 ported patch for bundled libffi in python by mattip review
Messages (5)
msg234119 - (view) Author: Robert Kuska (rkuska) * Date: 2015-01-16 09:41
Original bug report at https://bugzilla.redhat.com/show_bug.cgi?id=1174037
Additional informations at Issue #20160

Note that this was reproduced not only with separate libffi package but also with libffi bundled in python.
Reproduced with Python 2.7.9 but same issue should exists also in 3.4.x.

Richard Henderson provided fix in original bug report at bugzilla (attached).

Summary:
======================================================================
FAIL: test_struct_by_value (ctypes.test.test_win32.Structures)
----------------------------------------------------------------------
Traceback (most recent call last):
  File "/builddir/build/BUILD/Python-2.7.9/Lib/ctypes/test/test_win32.py", line 112, in test_struct_by_value
    self.assertEqual(ret.left, left.value)
AssertionError: -200 != 10
----------------------------------------------------------------------

(gdb) b ReturnRect
Function "ReturnRect" not defined.
Make breakpoint pending on future shared library load? (y or [n]) y
Breakpoint 1 (ReturnRect) pending.
(gdb) run test_win32.py
Starting program: /usr/bin/python test_win32.py
Missing separate debuginfos, use: debuginfo-install glibc-2.20.90-12.fc22.aarch64
[Thread debugging using libthread_db enabled]
Using host libthread_db library "/lib64/libthread_db.so.1".

Breakpoint 1, ReturnRect (i=0, ar=..., br=0x59b750, cp=..., dr=..., er=0x59b750, fp=..., 
    gr=<error reading variable: Cannot access memory at address 0xffff000000000000>)
    at /usr/src/debug/Python-2.7.9/Modules/_ctypes/_ctypes_test.c:552
552	    if (ar.left + br->left + dr.left + er->left + gr.left != left * 5)
(gdb) p fp
$1 = {x = 4396722194992, y = 5879632}
(gdb) p cp
$2 = {x = 15, y = 25}
(gdb)

Consider to apply a patch or update bundled libffi.
msg234148 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2015-01-16 21:41
>  libffi-3.2.1 was released on November 12, 2014. You can ftp it from sourceware.org:/pub/libffi/libffi-3.2.1.tar.gz. 

Does this version include libffi-henderson patch?
msg235601 - (view) Author: Robert Kuska (rkuska) * Date: 2015-02-09 11:51
Sorry for the late answer, I forgot about this issue.

3.2.1 doesn't contain required fix(sorry for the misleading suggestion 'or update bundled libffi' from report) but master branch at upstream repo (https://github.com/atgreen/libffi) does.
msg401510 - (view) Author: Irit Katriel (iritkatriel) * (Python committer) Date: 2021-09-09 18:40
I believe we are on libffi 3.3 now - the code on that branch looks very different from this patch. Can we close this issue?
msg401520 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2021-09-09 21:14
> Original bug report at https://bugzilla.redhat.com/show_bug.cgi?id=1174037

The bug was reported on Fedora (Linux).

We do now have a multiple AArch64 buildbots running Fedora and the whole test suite now pass there.

Example with "aarch64 Fedora Stable 3.x":
https://buildbot.python.org/all/#/builders/125/builds/612

"0:00:03 load avg: 4.20 [ 62/427] test_ctypes passed"

So yes, this issue can now be fixed ;-)

FYI Python is built with --with-system-ffi on Fedora, but buildbots don't use this flag. I'm working on using --with-system-ffi on buildbots, see:
https://github.com/python/buildmaster-config/pull/264
History
Date User Action Args
2021-09-09 21:16:14iritkatrielsetstatus: open -> closed
2021-09-09 21:14:12vstinnersetstatus: pending -> open

messages: + msg401520
2021-09-09 18:41:49iritkatrielsetstatus: closed -> pending
2021-09-09 18:40:23iritkatrielsetstatus: open -> closed

nosy: + iritkatriel
messages: + msg401510

resolution: out of date
stage: resolved
2015-02-09 22:19:10pitrousetnosy: + doko, meador.inge
2015-02-09 11:51:56rkuskasetmessages: + msg235601
2015-01-16 21:41:09vstinnersetnosy: + vstinner
messages: + msg234148
2015-01-16 10:55:04sYnfosetnosy: + sYnfo
2015-01-16 09:43:32rkuskasetfiles: + libffi-mattip.patch
keywords: + patch
2015-01-16 09:41:23rkuskacreate